hinfo: Adding man page
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN = $(top_srcdir)/autotools/check-man
26 CHECK_VERSION = $(top_srcdir)/autotools/check-version
27 CHECK_NEWS = $(top_srcdir)/autotools/check-news
28 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
29 DOCPP = $(top_srcdir)/autotools/docpp
30 REPLACE_VARS_SED = autotools/replace_vars.sed
31 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
32 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
33
34 # Note: these are automake-specific variables, and must be named after
35 # the directory + 'dir' suffix
36 clientdir = $(pkgpythondir)/client
37 hypervisordir = $(pkgpythondir)/hypervisor
38 httpdir = $(pkgpythondir)/http
39 masterddir = $(pkgpythondir)/masterd
40 confddir = $(pkgpythondir)/confd
41 rapidir = $(pkgpythondir)/rapi
42 serverdir = $(pkgpythondir)/server
43 watcherdir = $(pkgpythondir)/watcher
44 impexpddir = $(pkgpythondir)/impexpd
45 utilsdir = $(pkgpythondir)/utils
46 toolsdir = $(pkglibdir)/tools
47 iallocatorsdir = $(pkglibdir)/iallocators
48 pytoolsdir = $(pkgpythondir)/tools
49 docdir = $(datadir)/doc/$(PACKAGE)
50
51 # Delete output file if an error occurred while building it
52 .DELETE_ON_ERROR:
53
54 HTOOLS_DIRS = \
55         htools \
56         htools/Ganeti \
57         htools/Ganeti/HTools \
58         htools/Ganeti/HTools/Program
59
60 DIRS = \
61         autotools \
62         daemons \
63         devel \
64         doc \
65         doc/examples \
66         doc/examples/hooks \
67         doc/examples/gnt-debug \
68         $(HTOOLS_DIRS) \
69         lib \
70         lib/client \
71         lib/build \
72         lib/confd \
73         lib/http \
74         lib/hypervisor \
75         lib/impexpd \
76         lib/masterd \
77         lib/rapi \
78         lib/server \
79         lib/tools \
80         lib/utils \
81         lib/watcher \
82         man \
83         qa \
84         test \
85         test/data \
86         test/data/ovfdata \
87         test/data/ovfdata/other \
88         tools
89
90 BUILDTIME_DIR_AUTOCREATE = \
91         scripts \
92         $(APIDOC_DIR) \
93         $(APIDOC_PY_DIR) \
94         $(APIDOC_HS_DIR) \
95         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
96         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
97         $(COVERAGE_DIR) \
98         $(COVERAGE_PY_DIR) \
99         $(COVERAGE_HS_DIR) \
100         .hpc
101
102 BUILDTIME_DIRS = \
103         $(BUILDTIME_DIR_AUTOCREATE) \
104         doc/html
105
106 DIRCHECK_EXCLUDE = \
107         $(BUILDTIME_DIRS) \
108         ganeti-[0-9]*.[0-9]*.[0-9]* \
109         doc/html/_*
110
111 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
112
113 # some helper vars
114 COVERAGE_DIR = doc/coverage
115 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
116 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
117 APIDOC_DIR = doc/api
118 APIDOC_PY_DIR = $(APIDOC_DIR)/py
119 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
120
121 MAINTAINERCLEANFILES = \
122         $(docpng) \
123         $(maninput) \
124         doc/install-quick.rst \
125         doc/news.rst \
126         doc/upgrade.rst \
127         vcs-version
128
129 maintainer-clean-local:
130         rm -rf $(BUILDTIME_DIRS)
131
132 CLEANFILES = \
133         $(addsuffix /*.py[co],$(DIRS)) \
134         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
135         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
136         $(all_dirfiles) \
137         $(PYTHON_BOOTSTRAP) \
138         epydoc.conf \
139         autotools/replace_vars.sed \
140         daemons/daemon-util \
141         daemons/ganeti-cleaner \
142         devel/upload \
143         $(BUILT_EXAMPLES) \
144         doc/examples/bash_completion \
145         lib/_generated_rpc.py \
146         $(man_MANS) \
147         $(manhtml) \
148         tools/kvm-ifup \
149         stamp-srclinks \
150         $(nodist_pkgpython_PYTHON) \
151         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
152         .hpc/*.mix htools/*.tix \
153         doc/hs-lint.html
154
155 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
156 # it'll cause the target to rebuild every time.
157 BUILT_SOURCES = \
158   $(built_base_sources) \
159         $(BUILT_PYTHON_SOURCES) \
160         $(PYTHON_BOOTSTRAP)
161
162 built_base_sources = \
163         ganeti \
164         stamp-srclinks \
165         $(all_dirfiles)
166
167 built_python_base_sources = \
168         lib/_autoconf.py \
169         lib/_vcsversion.py
170
171 BUILT_PYTHON_SOURCES = \
172         $(built_python_base_sources) \
173         lib/_generated_rpc.py
174
175 # Generating the RPC wrappers depends on many things, so make sure it's built at
176 # the end of the built sources
177 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
178
179 # these are all built from the underlying %.in sources
180 BUILT_EXAMPLES = \
181         doc/examples/ganeti-kvm-poweroff.initd \
182         doc/examples/ganeti.cron \
183         doc/examples/ganeti.initd \
184         doc/examples/gnt-config-backup \
185         doc/examples/hooks/ipsec
186
187 nodist_pkgpython_PYTHON = \
188         $(BUILT_PYTHON_SOURCES)
189
190 noinst_PYTHON = \
191         lib/build/__init__.py \
192         lib/build/sphinx_ext.py
193
194 pkgpython_PYTHON = \
195         lib/__init__.py \
196         lib/asyncnotifier.py \
197         lib/backend.py \
198         lib/bdev.py \
199         lib/bootstrap.py \
200         lib/cli.py \
201         lib/cmdlib.py \
202         lib/compat.py \
203         lib/config.py \
204         lib/constants.py \
205         lib/daemon.py \
206         lib/errors.py \
207         lib/ht.py \
208         lib/jqueue.py \
209         lib/jstore.py \
210         lib/locking.py \
211         lib/luxi.py \
212         lib/mcpu.py \
213         lib/netutils.py \
214         lib/objects.py \
215         lib/opcodes.py \
216         lib/ovf.py \
217         lib/qlang.py \
218         lib/query.py \
219         lib/rpc.py \
220         lib/rpc_defs.py \
221         lib/runtime.py \
222         lib/serializer.py \
223         lib/ssconf.py \
224         lib/ssh.py \
225         lib/storage.py \
226         lib/uidpool.py \
227         lib/workerpool.py
228
229 client_PYTHON = \
230         lib/client/__init__.py \
231         lib/client/gnt_backup.py \
232         lib/client/gnt_cluster.py \
233         lib/client/gnt_debug.py \
234         lib/client/gnt_group.py \
235         lib/client/gnt_instance.py \
236         lib/client/gnt_job.py \
237         lib/client/gnt_node.py \
238         lib/client/gnt_os.py
239
240 hypervisor_PYTHON = \
241         lib/hypervisor/__init__.py \
242         lib/hypervisor/hv_base.py \
243         lib/hypervisor/hv_chroot.py \
244         lib/hypervisor/hv_fake.py \
245         lib/hypervisor/hv_kvm.py \
246         lib/hypervisor/hv_lxc.py \
247         lib/hypervisor/hv_xen.py
248
249 rapi_PYTHON = \
250         lib/rapi/__init__.py \
251         lib/rapi/baserlib.py \
252         lib/rapi/client.py \
253         lib/rapi/client_utils.py \
254         lib/rapi/connector.py \
255         lib/rapi/rlib2.py \
256         lib/rapi/testutils.py
257
258 http_PYTHON = \
259         lib/http/__init__.py \
260         lib/http/auth.py \
261         lib/http/client.py \
262         lib/http/server.py
263
264 confd_PYTHON = \
265         lib/confd/__init__.py \
266         lib/confd/client.py \
267         lib/confd/querylib.py \
268         lib/confd/server.py
269
270 masterd_PYTHON = \
271         lib/masterd/__init__.py \
272         lib/masterd/instance.py
273
274 impexpd_PYTHON = \
275         lib/impexpd/__init__.py
276
277 watcher_PYTHON = \
278         lib/watcher/__init__.py \
279         lib/watcher/nodemaint.py \
280         lib/watcher/state.py
281
282 server_PYTHON = \
283         lib/server/__init__.py \
284         lib/server/confd.py \
285         lib/server/masterd.py \
286         lib/server/noded.py \
287         lib/server/rapi.py
288
289 pytools_PYTHON = \
290         lib/tools/__init__.py \
291         lib/tools/ensure_dirs.py
292
293 utils_PYTHON = \
294         lib/utils/__init__.py \
295         lib/utils/algo.py \
296         lib/utils/filelock.py \
297         lib/utils/hash.py \
298         lib/utils/io.py \
299         lib/utils/log.py \
300         lib/utils/mlock.py \
301         lib/utils/nodesetup.py \
302         lib/utils/process.py \
303         lib/utils/retry.py \
304         lib/utils/text.py \
305         lib/utils/wrapper.py \
306         lib/utils/x509.py
307
308 docrst = \
309         doc/admin.rst \
310         doc/design-2.0.rst \
311         doc/design-2.1.rst \
312         doc/design-2.2.rst \
313         doc/design-2.3.rst \
314         doc/design-htools-2.3.rst \
315         doc/design-2.4.rst \
316         doc/design-2.5.rst \
317         doc/design-draft.rst \
318         doc/design-oob.rst \
319         doc/design-cpu-pinning.rst \
320         doc/design-query2.rst \
321         doc/design-x509-ca.rst \
322         doc/design-http-server.rst \
323         doc/design-impexp2.rst \
324         doc/design-lu-generated-jobs.rst \
325         doc/design-multi-reloc.rst \
326         doc/design-network.rst \
327         doc/design-chained-jobs.rst \
328         doc/design-ovf-support.rst \
329         doc/design-resource-model.rst \
330         doc/cluster-merge.rst \
331         doc/design-shared-storage.rst \
332         doc/design-node-state-cache.rst \
333         doc/design-virtual-clusters.rst \
334         doc/devnotes.rst \
335         doc/glossary.rst \
336         doc/hooks.rst \
337         doc/iallocator.rst \
338         doc/index.rst \
339         doc/install-quick.rst \
340         doc/install.rst \
341         doc/locking.rst \
342         doc/move-instance.rst \
343         doc/news.rst \
344         doc/rapi.rst \
345         doc/security.rst \
346         doc/upgrade.rst \
347         doc/walkthrough.rst
348
349 HS_PROGS = htools/htools
350 HS_BIN_ROLES = hbal hscan hspace hinfo
351
352 HS_ALL_PROGS = $(HS_PROGS) htools/test
353 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
354 # we don't add -Werror by default
355 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
356 # extra flags that can be overriden on the command line
357 HEXTRA =
358 # internal extra flags (used for htools/test mainly)
359 HEXTRA_INT =
360 # exclude options for coverage reports
361 HPCEXCL = --exclude Main \
362         --exclude Ganeti.Constants \
363         --exclude Ganeti.THH \
364         --exclude Ganeti.HTools.QC \
365         --exclude Ganeti.HTools.QCHelper \
366         --exclude Ganeti.HTools.Version
367
368 HS_LIB_SRCS = \
369         htools/Ganeti/HTools/CLI.hs \
370         htools/Ganeti/HTools/Cluster.hs \
371         htools/Ganeti/HTools/Compat.hs \
372         htools/Ganeti/HTools/Container.hs \
373         htools/Ganeti/HTools/ExtLoader.hs \
374         htools/Ganeti/HTools/Group.hs \
375         htools/Ganeti/HTools/IAlloc.hs \
376         htools/Ganeti/HTools/Instance.hs \
377         htools/Ganeti/HTools/JSON.hs \
378         htools/Ganeti/HTools/Loader.hs \
379         htools/Ganeti/HTools/Luxi.hs \
380         htools/Ganeti/HTools/Node.hs \
381         htools/Ganeti/HTools/PeerMap.hs \
382         htools/Ganeti/HTools/QC.hs \
383         htools/Ganeti/HTools/QCHelper.hs \
384         htools/Ganeti/HTools/Rapi.hs \
385         htools/Ganeti/HTools/Simu.hs \
386         htools/Ganeti/HTools/Text.hs \
387         htools/Ganeti/HTools/Types.hs \
388         htools/Ganeti/HTools/Utils.hs \
389         htools/Ganeti/HTools/Program.hs \
390         htools/Ganeti/HTools/Program/Hail.hs \
391         htools/Ganeti/HTools/Program/Hbal.hs \
392         htools/Ganeti/HTools/Program/Hinfo.hs \
393         htools/Ganeti/HTools/Program/Hscan.hs \
394         htools/Ganeti/HTools/Program/Hspace.hs \
395         htools/Ganeti/BasicTypes.hs \
396         htools/Ganeti/Jobs.hs \
397         htools/Ganeti/Luxi.hs \
398         htools/Ganeti/OpCodes.hs \
399         htools/Ganeti/THH.hs
400
401 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
402 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
403
404 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
405
406 # Note: we use here an order-only prerequisite, as the contents of
407 # _autoconf.py are not actually influencing the html build output: it
408 # has to exist in order for the sphinx module to be loaded
409 # successfully, but we certainly don't want the docs to be rebuilt if
410 # it changes
411 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
412         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
413         | $(BUILT_PYTHON_SOURCES)
414         @test -n "$(SPHINX)" || \
415             { echo 'sphinx-build' not found during configure; exit 1; }
416         @mkdir_p@ $(dir $@)
417         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
418             -d . \
419             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
420             -D release="$(PACKAGE_VERSION)" \
421             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
422         rm -f doc/html/.buildinfo doc/html/objects.inv
423         touch $@
424
425 doc/html: doc/html/index.html
426
427 doc/install-quick.rst: INSTALL
428 doc/news.rst: NEWS
429 doc/upgrade.rst: UPGRADE
430
431 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
432         set -e; \
433         { echo '.. This file is automatically updated at build time from $<.'; \
434           echo '.. Do not edit.'; \
435           echo; \
436           cat $<; \
437         } > $@
438
439 docdot = \
440         doc/arch-2.0.dot \
441         doc/design-2.1-lock-acquire.dot \
442         doc/design-2.1-lock-release.dot
443
444 docpng = $(patsubst %.dot,%.png,$(docdot))
445
446 # Things to build but not to install (add it to EXTRA_DIST if it should be
447 # distributed)
448 noinst_DATA = \
449         devel/upload \
450         doc/html \
451         $(BUILT_EXAMPLES) \
452         doc/examples/bash_completion \
453         $(manhtml)
454
455 gnt_scripts = \
456         scripts/gnt-backup \
457         scripts/gnt-cluster \
458         scripts/gnt-debug \
459         scripts/gnt-group \
460         scripts/gnt-instance \
461         scripts/gnt-job \
462         scripts/gnt-node \
463         scripts/gnt-os
464
465 PYTHON_BOOTSTRAP_SBIN = \
466         daemons/ganeti-confd \
467         daemons/ganeti-masterd \
468         daemons/ganeti-noded \
469         daemons/ganeti-watcher \
470         daemons/ganeti-rapi \
471         $(gnt_scripts)
472
473 PYTHON_BOOTSTRAP = \
474         $(PYTHON_BOOTSTRAP_SBIN) \
475         tools/ensure-dirs
476
477 qa_scripts = \
478         qa/ganeti-qa.py \
479         qa/qa_cluster.py \
480         qa/qa_config.py \
481         qa/qa_daemon.py \
482         qa/qa_env.py \
483         qa/qa_error.py \
484         qa/qa_group.py \
485         qa/qa_instance.py \
486         qa/qa_node.py \
487         qa/qa_os.py \
488         qa/qa_rapi.py \
489         qa/qa_tags.py \
490         qa/qa_utils.py
491
492 bin_SCRIPTS =
493 if WANT_HTOOLS
494 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
495 install-exec-hook:
496         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
497 # FIXME: this is a hardcoded logic, instead of auto-resolving
498         $(LN_S) -f ../../../bin/htools \
499                    $(DESTDIR)$(iallocatorsdir)/hail
500         for role in $(HS_BIN_ROLES); do \
501                 $(LN_S) -f htools \
502                            $(DESTDIR)$(bindir)/$$role ; \
503         done
504 endif
505
506 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
507         @if [ -z "$(HTOOLS)" ]; then \
508           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
509           exit 1; \
510         fi
511         @BINARY=$(@:htools/%=%); \
512         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
513           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
514           exit 1; \
515         fi
516         BINARY=$(@:htools/%=%); $(GHC) --make \
517           $(HFLAGS) \
518           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
519           -osuf $$BINARY.o -hisuf $$BINARY.hi \
520           $(HEXTRA) $(HEXTRA_INT) $@
521
522 # for the htools/test binary, we need to enable profiling/coverage
523 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
524         -fno-warn-monomorphism-restriction -fno-warn-orphans \
525         -fno-warn-missing-methods -fno-warn-unused-imports
526
527 # rules for building profiling-enabled versions of the haskell
528 # programs: hs-prof does the full two-step build, whereas
529 # hs-prof-quick does only the final rebuild (hs-prof must have been
530 # run before)
531 .PHONY: hs-prof hs-prof-quick
532 hs-prof:
533         $(MAKE) clean
534         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
535         rm -f $(HS_ALL_PROGS)
536         $(MAKE) hs-prof-quick
537
538 hs-prof-quick:
539         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
540
541 dist_sbin_SCRIPTS = \
542         tools/ganeti-listrunner
543
544 nodist_sbin_SCRIPTS = \
545         $(PYTHON_BOOTSTRAP_SBIN) \
546         daemons/ganeti-cleaner
547
548 python_scripts = \
549         tools/burnin \
550         tools/cfgshell \
551         tools/cfgupgrade \
552         tools/cfgupgrade12 \
553         tools/cluster-merge \
554         tools/confd-client \
555         tools/fmtjson \
556         tools/lvmstrap \
557         tools/move-instance \
558         tools/ovfconverter \
559         tools/setup-ssh \
560         tools/sanitize-config
561
562 dist_tools_SCRIPTS = \
563         $(python_scripts) \
564         tools/kvm-console-wrapper \
565         tools/xm-console-wrapper \
566         tools/master-ip-setup
567
568 pkglib_python_scripts = \
569         daemons/import-export \
570         tools/check-cert-expired
571
572 nodist_pkglib_python_scripts = \
573         tools/ensure-dirs
574
575 pkglib_SCRIPTS = \
576         daemons/daemon-util \
577         tools/kvm-ifup \
578         $(pkglib_python_scripts)
579
580 nodist_pkglib_SCRIPTS = \
581         $(nodist_pkglib_python_scripts)
582
583 EXTRA_DIST = \
584         NEWS \
585         UPGRADE \
586         epydoc.conf.in \
587         pylintrc \
588         autotools/build-bash-completion \
589         autotools/build-rpc \
590         autotools/check-header \
591         autotools/check-python-code \
592         autotools/check-imports \
593         autotools/check-man \
594         autotools/check-news \
595         autotools/check-tar \
596         autotools/check-version \
597         autotools/convert-constants \
598         autotools/docpp \
599         autotools/gen-coverage \
600         autotools/testrunner \
601         $(RUN_IN_TEMPDIR) \
602         daemons/daemon-util.in \
603         daemons/ganeti-cleaner.in \
604         $(pkglib_python_scripts) \
605         devel/upload.in \
606         tools/kvm-ifup.in \
607         $(docdot) \
608         $(docpng) \
609         $(docrst) \
610         doc/conf.py \
611         doc/html \
612         $(BUILT_EXAMPLES:%=%.in) \
613         doc/examples/ganeti.default \
614         doc/examples/ganeti.default-debug \
615         doc/examples/hooks/ethers \
616         doc/examples/gnt-debug/README \
617         doc/examples/gnt-debug/delay0.json \
618         doc/examples/gnt-debug/delay50.json \
619         test/lockperf.py \
620         test/testutils.py \
621         test/mocks.py \
622         $(dist_TESTS) \
623         $(TEST_FILES) \
624         man/footer.rst \
625         $(manrst) \
626         $(maninput) \
627         qa/qa-sample.json \
628         $(qa_scripts) \
629         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
630         $(HS_PROG_SRCS) \
631         htools/lint-hints.hs
632
633 man_MANS = \
634         man/ganeti.7 \
635         man/ganeti-cleaner.8 \
636         man/ganeti-confd.8 \
637         man/ganeti-listrunner.8 \
638         man/ganeti-masterd.8 \
639         man/ganeti-noded.8 \
640         man/ganeti-os-interface.7 \
641         man/ganeti-rapi.8 \
642         man/ganeti-watcher.8 \
643         man/gnt-backup.8 \
644         man/gnt-cluster.8 \
645         man/gnt-debug.8 \
646         man/gnt-group.8 \
647         man/gnt-instance.8 \
648         man/gnt-job.8 \
649         man/gnt-node.8 \
650         man/gnt-os.8 \
651         man/hail.1 \
652         man/hbal.1 \
653         man/hinfo.1 \
654         man/hscan.1 \
655         man/hspace.1 \
656         man/htools.1
657
658 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
659 manhtml = $(patsubst %.rst,%.html,$(manrst))
660 mangen = $(patsubst %.rst,%.gen,$(manrst))
661 maninput = \
662         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
663         $(patsubst %.html,%.html.in,$(manhtml)) \
664         man/footer.man man/footer.html $(mangen)
665
666 TEST_FILES = \
667         test/data/bdev-drbd-8.0.txt \
668         test/data/bdev-drbd-8.3.txt \
669         test/data/bdev-drbd-disk.txt \
670         test/data/bdev-drbd-net-ip4.txt \
671         test/data/bdev-drbd-net-ip6.txt \
672         test/data/cert1.pem \
673         test/data/ip-addr-show-dummy0.txt \
674         test/data/ip-addr-show-lo-ipv4.txt \
675         test/data/ip-addr-show-lo-ipv6.txt \
676         test/data/ip-addr-show-lo-oneline-ipv4.txt \
677         test/data/ip-addr-show-lo-oneline-ipv6.txt \
678         test/data/ip-addr-show-lo-oneline.txt \
679         test/data/ip-addr-show-lo.txt \
680         test/data/proc_drbd8.txt \
681         test/data/proc_drbd80-emptyline.txt \
682         test/data/proc_drbd83.txt \
683         test/data/proc_drbd83_sync.txt \
684         test/data/proc_drbd83_sync_krnl2.6.39.txt \
685         test/data/kvm_1.0_help.txt \
686         test/data/kvm_0.15.90_help.txt \
687         test/data/kvm_0.12.5_help.txt \
688         test/data/kvm_0.9.1_help.txt \
689         test/data/sys_drbd_usermode_helper.txt \
690         test/data/ovfdata/compr_disk.vmdk.gz \
691         test/data/ovfdata/config.ini \
692         test/data/ovfdata/corrupted_resources.ovf \
693         test/data/ovfdata/empty.ini \
694         test/data/ovfdata/empty.ovf \
695         test/data/ovfdata/ganeti.mf \
696         test/data/ovfdata/ganeti.ovf \
697         test/data/ovfdata/gzip_disk.ovf \
698         test/data/ovfdata/new_disk.vmdk \
699         test/data/ovfdata/no_disk.ini \
700         test/data/ovfdata/no_disk_in_ref.ovf \
701         test/data/ovfdata/no_os.ini \
702         test/data/ovfdata/no_ovf.ova \
703         test/data/ovfdata/ova.ova \
704         test/data/ovfdata/second_disk.vmdk \
705         test/data/ovfdata/rawdisk.raw \
706         test/data/ovfdata/unsafe_path.ini \
707         test/data/ovfdata/virtualbox.ovf \
708         test/data/ovfdata/wrong_extension.ovd \
709         test/data/ovfdata/wrong_config.ini \
710         test/data/ovfdata/wrong_manifest.mf \
711         test/data/ovfdata/wrong_manifest.ovf \
712         test/data/ovfdata/wrong_ova.ova \
713         test/data/ovfdata/wrong_xml.ovf \
714         test/data/ovfdata/other/rawdisk.raw \
715         test/import-export_unittest-helper
716
717 python_tests = \
718         test/ganeti.asyncnotifier_unittest.py \
719         test/ganeti.backend_unittest.py \
720         test/ganeti.bdev_unittest.py \
721         test/ganeti.cli_unittest.py \
722         test/ganeti.client.gnt_cluster_unittest.py \
723         test/ganeti.client.gnt_instance_unittest.py \
724         test/ganeti.daemon_unittest.py \
725         test/ganeti.cmdlib_unittest.py \
726         test/ganeti.compat_unittest.py \
727         test/ganeti.confd.client_unittest.py \
728         test/ganeti.config_unittest.py \
729         test/ganeti.constants_unittest.py \
730         test/ganeti.errors_unittest.py \
731         test/ganeti.hooks_unittest.py \
732         test/ganeti.ht_unittest.py \
733         test/ganeti.http_unittest.py \
734         test/ganeti.hypervisor_unittest.py \
735         test/ganeti.hypervisor.hv_chroot_unittest.py \
736         test/ganeti.hypervisor.hv_fake_unittest.py \
737         test/ganeti.hypervisor.hv_kvm_unittest.py \
738         test/ganeti.hypervisor.hv_lxc_unittest.py \
739         test/ganeti.hypervisor.hv_xen_unittest.py \
740         test/ganeti.impexpd_unittest.py \
741         test/ganeti.jqueue_unittest.py \
742         test/ganeti.locking_unittest.py \
743         test/ganeti.luxi_unittest.py \
744         test/ganeti.masterd.instance_unittest.py \
745         test/ganeti.mcpu_unittest.py \
746         test/ganeti.netutils_unittest.py \
747         test/ganeti.objects_unittest.py \
748         test/ganeti.opcodes_unittest.py \
749         test/ganeti.ovf_unittest.py \
750         test/ganeti.qlang_unittest.py \
751         test/ganeti.query_unittest.py \
752         test/ganeti.rapi.baserlib_unittest.py \
753         test/ganeti.rapi.client_unittest.py \
754         test/ganeti.rapi.resources_unittest.py \
755         test/ganeti.rapi.rlib2_unittest.py \
756         test/ganeti.rapi.testutils_unittest.py \
757         test/ganeti.rpc_unittest.py \
758         test/ganeti.runtime_unittest.py \
759         test/ganeti.serializer_unittest.py \
760         test/ganeti.ssh_unittest.py \
761         test/ganeti.tools.ensure_dirs_unittest.py \
762         test/ganeti.uidpool_unittest.py \
763         test/ganeti.utils.algo_unittest.py \
764         test/ganeti.utils.filelock_unittest.py \
765         test/ganeti.utils.hash_unittest.py \
766         test/ganeti.utils.io_unittest.py \
767         test/ganeti.utils.log_unittest.py \
768         test/ganeti.utils.mlock_unittest.py \
769         test/ganeti.utils.nodesetup_unittest.py \
770         test/ganeti.utils.process_unittest.py \
771         test/ganeti.utils.retry_unittest.py \
772         test/ganeti.utils.text_unittest.py \
773         test/ganeti.utils.wrapper_unittest.py \
774         test/ganeti.utils.x509_unittest.py \
775         test/ganeti.utils_unittest.py \
776         test/ganeti.workerpool_unittest.py \
777         test/cfgupgrade_unittest.py \
778         test/docs_unittest.py \
779         test/pycurl_reset_unittest.py \
780         test/tempfile_fork_unittest.py
781 if HAS_FAKEROOT
782 python_tests += test/ganeti.utils.io_unittest-runasroot.py
783 endif
784
785 haskell_tests = htools/test
786
787 dist_TESTS = \
788         test/check-cert-expired_unittest.bash \
789         test/daemon-util_unittest.bash \
790         test/ganeti-cleaner_unittest.bash \
791         test/import-export_unittest.bash \
792         $(python_tests)
793
794 nodist_TESTS =
795 if WANT_HTOOLSTESTS
796 nodist_TESTS += $(haskell_tests)
797 endif
798
799 TESTS = $(dist_TESTS) $(nodist_TESTS)
800
801 # Environment for all tests
802 PLAIN_TESTS_ENVIRONMENT = \
803         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) \
804         FAKEROOT=$(FAKEROOT_PATH) $(RUN_IN_TEMPDIR)
805
806 # Environment for tests run by automake
807 TESTS_ENVIRONMENT = \
808         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
809
810 all_python_code = \
811         $(dist_sbin_SCRIPTS) \
812         $(python_scripts) \
813         $(pkglib_python_scripts) \
814         $(nodist_pkglib_python_scripts) \
815         $(python_tests) \
816         $(pkgpython_PYTHON) \
817         $(client_PYTHON) \
818         $(hypervisor_PYTHON) \
819         $(rapi_PYTHON) \
820         $(server_PYTHON) \
821         $(pytools_PYTHON) \
822         $(http_PYTHON) \
823         $(confd_PYTHON) \
824         $(masterd_PYTHON) \
825         $(impexpd_PYTHON) \
826         $(utils_PYTHON) \
827         $(watcher_PYTHON) \
828         $(noinst_PYTHON) \
829         $(qa_scripts)
830
831 srclink_files = \
832         man/footer.rst \
833         test/check-cert-expired_unittest.bash \
834         test/daemon-util_unittest.bash \
835         test/ganeti-cleaner_unittest.bash \
836         test/import-export_unittest.bash \
837         $(all_python_code) \
838         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
839
840 check_python_code = \
841         $(BUILD_BASH_COMPLETION) \
842         $(CHECK_IMPORTS) \
843         $(CHECK_HEADER) \
844         $(DOCPP) \
845         $(all_python_code)
846
847 lint_python_code = \
848         ganeti \
849         ganeti/http/server.py \
850         $(dist_sbin_SCRIPTS) \
851         $(python_scripts) \
852         $(pkglib_python_scripts) \
853         $(BUILD_BASH_COMPLETION) \
854         $(CHECK_IMPORTS) \
855         $(CHECK_HEADER) \
856         $(DOCPP) \
857         $(PYTHON_BOOTSTRAP)
858
859 standalone_python_modules = \
860         lib/rapi/client.py \
861         tools/ganeti-listrunner
862
863 pep8_python_code = \
864         ganeti \
865         ganeti/http/server.py \
866         $(dist_sbin_SCRIPTS) \
867         $(python_scripts) \
868         $(pkglib_python_scripts) \
869         $(BUILD_BASH_COMPLETION) \
870         $(CHECK_HEADER) \
871         $(DOCPP) \
872         $(PYTHON_BOOTSTRAP) \
873         qa
874
875 test/daemon-util_unittest.bash: daemons/daemon-util
876
877 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
878
879 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
880         sed -f $(REPLACE_VARS_SED) < $< > $@
881         chmod +x $@
882
883 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
884         sed -f $(REPLACE_VARS_SED) < $< > $@
885         chmod u+x $@
886
887 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
888         sed -f $(REPLACE_VARS_SED) < $< > $@
889         chmod +x $@
890
891 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
892         sed -f $(REPLACE_VARS_SED) < $< > $@
893
894 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
895         sed -f $(REPLACE_VARS_SED) < $< > $@
896
897 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
898         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
899         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
900
901 doc/%.png: doc/%.dot
902         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
903         $(DOT) -Tpng -o $@ $<
904
905 man/footer.man: man/footer.rst
906         @test -n "$(PANDOC)" || \
907           { echo 'pandoc' not found during configure; exit 1; }
908         $(PANDOC) -f rst -t man -o $@ $<
909
910 man/footer.html: man/footer.rst
911         @test -n "$(PANDOC)" || \
912           { echo 'pandoc' not found during configure; exit 1; }
913         $(PANDOC) -f rst -t html -o $@ $<
914
915 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
916         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
917
918 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
919         @test -n "$(PANDOC)" || \
920           { echo 'pandoc' not found during configure; exit 1; }
921         set -o pipefail ; \
922         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
923           sed -e 's/\\@/@/g' > $@
924         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
925
926 man/%.html.in: man/%.gen man/footer.html
927         @test -n "$(PANDOC)" || \
928           { echo 'pandoc' not found during configure; exit 1; }
929         set -o pipefail ; \
930         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
931           sed -e 's/\\@/@/g' > $@
932
933 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
934         sed -f $(REPLACE_VARS_SED) < $< > $@
935
936 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
937         sed -f $(REPLACE_VARS_SED) < $< > $@
938
939 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
940         sed -f $(REPLACE_VARS_SED) < $< > $@
941
942 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
943         sed -f $(REPLACE_VARS_SED) < $< > $@
944
945 epydoc.conf: epydoc.conf.in Makefile
946         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
947
948 vcs-version:
949         if test -d .git; then \
950           git describe > $@; \
951         elif test ! -f $@ ; then \
952           echo "Cannot auto-generate $@ file"; exit 1; \
953         fi
954
955 .PHONY: regen-vcs-version
956 regen-vcs-version:
957         set -e; \
958         cd $(srcdir); \
959         if test -d .git; then \
960           rm -f vcs-version; \
961           $(MAKE) vcs-version; \
962         fi
963
964 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
965         set -e; \
966         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
967         sed -e "s/%ver%/$$VCSVER/" < $< > $@
968
969 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
970         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
971         | lib/_vcsversion.py
972         set -e; \
973         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
974
975 lib/_autoconf.py: Makefile | lib/.dir
976         set -e; \
977         { echo '# This file is automatically generated, do not edit!'; \
978           echo '#'; \
979           echo ''; \
980           echo '"""Build-time configuration for Ganeti.'; \
981           echo '';\
982           echo 'This file is autogenerated by the build process.'; \
983           echo 'For any changes you need to re-run ./configure (and'; \
984           echo 'not edit by hand).'; \
985           echo ''; \
986           echo '"""'; \
987           echo ''; \
988           echo '# pylint: disable=C0301,C0324'; \
989           echo '# because this is autogenerated, we do not want'; \
990           echo '# style warnings' ; \
991           echo ''; \
992           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
993           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
994           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
995           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
996           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
997           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
998           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
999           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1000           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1001           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1002           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1003           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1004           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1005           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1006           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1007           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1008           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1009           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1010           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1011           echo "KVM_PATH = '$(KVM_PATH)'"; \
1012           echo "IP_PATH = '$(IP_PATH)'"; \
1013           echo "SOCAT_PATH = '$(SOCAT)'"; \
1014           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1015           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1016           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1017           echo "TOOLSDIR = '$(toolsdir)'"; \
1018           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1019           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1020           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1021           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1022           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1023           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1024           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1025           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1026           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1027           echo "RAPI_USER = '$(RAPI_USER)'"; \
1028           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1029           echo "CONFD_USER = '$(CONFD_USER)'"; \
1030           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1031           echo "NODED_USER = '$(NODED_USER)'"; \
1032           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1033           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1034           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1035           if [ "$(HTOOLS)" ]; then \
1036             echo "HTOOLS = True"; \
1037           else \
1038             echo "HTOOLS = False"; \
1039           fi; \
1040           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1041         } > $@
1042
1043 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1044         set -e; \
1045         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1046         { echo '# This file is automatically generated, do not edit!'; \
1047           echo '#'; \
1048           echo ''; \
1049           echo '"""Build-time VCS version number for Ganeti.'; \
1050           echo '';\
1051           echo 'This file is autogenerated by the build process.'; \
1052           echo 'For any changes you need to re-run ./configure (and'; \
1053           echo 'not edit by hand).'; \
1054           echo ''; \
1055           echo '"""'; \
1056           echo ''; \
1057           echo '# pylint: disable=C0301,C0324'; \
1058           echo '# because this is autogenerated, we do not want'; \
1059           echo '# style warnings' ; \
1060           echo ''; \
1061           echo "VCS_VERSION = '$$VCSVER'"; \
1062         } > $@
1063
1064 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1065         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1066
1067 $(REPLACE_VARS_SED): Makefile
1068         set -e; \
1069         { echo 's#@PREFIX@#$(prefix)#g'; \
1070           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1071           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1072           echo 's#@BINDIR@#$(bindir)#g'; \
1073           echo 's#@SBINDIR@#$(sbindir)#g'; \
1074           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1075           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1076           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1077           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1078           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1079           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1080           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1081           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1082           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1083           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1084           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1085           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1086           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1087           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1088           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1089           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1090           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1091           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1092           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1093         } > $@
1094
1095 # Using deferred evaluation
1096 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1097 daemons/ganeti-watcher: MODULE = ganeti.watcher
1098 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1099 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1100
1101 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1102         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1103         set -e; \
1104         { echo '#!/usr/bin/python'; \
1105           echo '# This file is automatically generated, do not edit!'; \
1106           echo "# Edit $(MODULE) instead."; \
1107           echo; \
1108           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1109           echo; \
1110           echo '# pylint: disable=C0103'; \
1111           echo '# C0103: Invalid name'; \
1112           echo; \
1113           echo 'import sys'; \
1114           echo 'import $(MODULE) as main'; \
1115           echo; \
1116           echo '# Temporarily alias commands until bash completion'; \
1117           echo '# generator is changed'; \
1118           echo 'if hasattr(main, "commands"):'; \
1119           echo '  commands = main.commands # pylint: disable=E1101'; \
1120           echo 'if hasattr(main, "aliases"):'; \
1121           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1122           echo; \
1123           echo 'if __name__ == "__main__":'; \
1124           echo '  sys.exit(main.Main())'; \
1125         } > $@
1126         chmod u+x $@
1127
1128 # We need to create symlinks because "make distcheck" will not install Python
1129 # files when building.
1130 stamp-srclinks: Makefile | $(all_dirfiles)
1131         set -e; \
1132         for i in $(srclink_files); do \
1133                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1134                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1135                 fi; \
1136         done
1137         touch $@
1138
1139 .PHONY: ganeti
1140 ganeti:
1141         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1142
1143 .PHONY: check-dirs
1144 check-dirs: $(BUILT_SOURCES)
1145         @set -e; \
1146         find . -type d \( \( -name . \) -o \( \
1147                 -name .git -o \
1148                 -name autom4te.cache \
1149                 \) -prune -o -print \) | { \
1150                 error=; \
1151                 while read dir; do \
1152                         case "$$dir" in \
1153                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1154                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1155                         esac; \
1156                 done; \
1157                 for dir in $(DIRS); do \
1158                         if ! test -d "$$dir"; then \
1159                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1160                                 error=1; \
1161                         fi \
1162                 done; \
1163                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1164         }
1165
1166 .PHONY: check-local
1167 check-local: check-dirs $(BUILT_SOURCES)
1168         $(CHECK_PYTHON_CODE) $(check_python_code)
1169         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1170         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1171         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1172         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1173         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1174         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1175                 echo "Incorrect version in README, expected $$expver"; \
1176                 exit 1; \
1177         fi; \
1178         for file in doc/iallocator.rst doc/hooks.rst; do \
1179                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1180                         "Documents Ganeti version $$expver"; then \
1181                         echo "Incorrect version in $$file, expected $$expver"; \
1182                         exit 1; \
1183                 fi; \
1184         done
1185
1186 .PHONY: hs-check
1187 hs-check: htools/test
1188         @rm -f test.tix
1189         ./htools/test
1190
1191 # E111: indentation is not a multiple of four
1192 # E261: at least two spaces before inline comment
1193 # E501: line too long (80 characters)
1194 PEP8_IGNORE = E111,E261,E501
1195
1196 # For excluding pep8 expects filenames only, not whole paths
1197 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1198
1199 .PHONY: lint
1200 lint: $(BUILT_SOURCES)
1201         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1202         if test -z "$(PEP8)"; then \
1203                 echo '"pep8" not found during configure' >&2; \
1204         else \
1205                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1206                         $(pep8_python_code); \
1207         fi
1208         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1209         cd $(top_srcdir)/qa && \
1210           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1211           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1212
1213 .PHONY: hlint
1214 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1215         if tty -s; then C="-c"; else C=""; fi; \
1216         hlint --report=doc/hs-lint.html --cross $$C \
1217           --ignore "Use first" \
1218           --ignore "Use comparing" \
1219           --ignore "Use on" \
1220           --ignore "Use Control.Exception.catch" \
1221           --ignore "Reduce duplication" \
1222           --hint htools/lint-hints \
1223           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1224
1225 # a dist hook rule for updating the vcs-version file; this is
1226 # hardcoded due to where it needs to build the file...
1227 dist-hook:
1228         $(MAKE) regen-vcs-version && \
1229         rm -f $(top_distdir)/vcs-version && \
1230         cp -p $(srcdir)/vcs-version $(top_distdir)
1231
1232 # a distcheck hook rule for catching revision control directories
1233 distcheck-hook:
1234         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1235                 echo "Found revision control files in final archive." 1>&2; \
1236                 exit 1; \
1237         fi
1238         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1239                 echo "Found Python byte code in final archive." 1>&2; \
1240                 exit 1; \
1241         fi
1242         if find $(top_distdir) -name '*~' | grep .; then \
1243                 echo "Found backup files in final archive." 1>&2; \
1244                 exit 1; \
1245         fi
1246 # Empty files or directories should not be distributed. They can cause
1247 # unnecessary warnings for packagers. Directories used by automake during
1248 # distcheck must be excluded.
1249         if find $(top_distdir) -empty -and -not \( \
1250                         -path $(top_distdir)/_build -or \
1251                         -path $(top_distdir)/_inst \) | grep .; then \
1252                 echo "Found empty files or directories in final archive." 1>&2; \
1253                 exit 1; \
1254         fi
1255         if test -n "$(BUILD_RELEASE)" && \
1256            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1257                 echo "Found unreleased version in NEWS." >&2; \
1258                 exit 1; \
1259         fi
1260
1261 # When building a release, stricter checks should be used
1262 distcheck-release dist-release: export BUILD_RELEASE = 1
1263 distcheck-release: distcheck
1264
1265 dist-release: dist
1266         set -e; \
1267         for i in $(DIST_ARCHIVES); do \
1268                 echo -n "Checking $$i ... "; \
1269                 autotools/check-tar < $$i; \
1270                 echo OK; \
1271         done
1272
1273 install-exec-local:
1274         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1275           "$(DESTDIR)${localstatedir}/log/ganeti" \
1276           "$(DESTDIR)${localstatedir}/run/ganeti"
1277
1278 # To avoid conflicts between directory names and other targets, a file inside
1279 # the directory is used to ensure its existence.
1280 %.dir:
1281         @mkdir_p@ $* && touch $@
1282
1283 .PHONY: apidoc
1284 if WANT_HTOOLSAPIDOC
1285 apidoc: py-apidoc hs-apidoc
1286 else
1287 apidoc: py-apidoc
1288 endif
1289
1290 .PHONY: py-apidoc
1291 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1292         $(RUN_IN_TEMPDIR) epydoc -v \
1293                 --conf $(CURDIR)/epydoc.conf \
1294                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1295
1296 .PHONY: hs-apidoc
1297 hs-apidoc: $(HS_BUILT_SRCS)
1298         @test -n "$(HSCOLOUR)" || \
1299             { echo 'HsColour' not found during configure; exit 1; }
1300         @test -n "$(HADDOCK)" || \
1301             { echo 'haddock' not found during configure; exit 1; }
1302         rm -rf $(APIDOC_HS_DIR)/*
1303         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1304         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1305         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1306         set -e ; \
1307         cd htools; \
1308         if [ "$(HTOOLS_NOCURL)" ]; \
1309         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1310         else OPTGHC=""; \
1311         fi; \
1312         if [ "$(HTOOLS_PARALLEL3)" ]; \
1313         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1314         fi; \
1315         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1316         for file in $$RELSRCS; do \
1317                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1318                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1319         done ; \
1320         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1321                 -t ganeti-htools -p haddock-prologue \
1322                 --source-module="%{MODULE/.//}.html" \
1323                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1324                 $$OPTGHC \
1325                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1326
1327 .PHONY: TAGS
1328 TAGS: $(BUILT_SOURCES)
1329         rm -f TAGS
1330         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1331           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1332           -path './qa/*.py' | \
1333           etags -l python -
1334
1335 .PHONY: coverage
1336 if WANT_HTOOLS
1337 coverage: py-coverage hs-coverage
1338 else
1339 coverage: py-coverage
1340 endif
1341
1342 .PHONY: py-coverage
1343 py-coverage: $(BUILT_SOURCES) $(python_tests)
1344         set -e; \
1345         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1346         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1347         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1348         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1349         $(python_tests)
1350
1351 .PHONY: hs-coverage
1352 hs-coverage: $(haskell_tests)
1353         cd htools && rm -f *.tix *.mix && ./test
1354         @mkdir_p@ $(COVERAGE_HS_DIR)
1355         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1356         hpc report htools/test $(HPCEXCL)
1357         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1358
1359 # Special "kind-of-QA" target for htools, needs special setup (all
1360 # tools compiled with -fhpc)
1361 .PHONY: live-test
1362 live-test: all
1363         set -e ; \
1364         cd htools; \
1365         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1366         rm -f *.tix *.mix; \
1367         ./live-test.sh; \
1368         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1369           --output=live-test.tix ; \
1370         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1371         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1372                 --srcdir=.. $(HPCEXCL) ; \
1373         hpc report --srcdir=.. live-test $(HPCEXCL)
1374
1375 commit-check: distcheck lint apidoc
1376
1377 -include ./Makefile.local
1378
1379 # vim: set noet :